unit ListenThread;

interface

uses
  Classes, SysUtils, WinSock;

type
   TListenThread = class(TThread)
   private
      { Private declarations }
   protected
      RemUser     : TSockAddr;
      len         : integer;
      ErrMsg      : string;
      procedure   Execute; override;
      procedure   UpdateHits;
      procedure   ShowError;
   public
      LisSock     : TSocket;
   end;

implementation

uses Main, SockUtil, DataThread;

{ TListenThread }

procedure TListenThread.Execute;
var
   DataSock : TSocket;
   dt       : TDataThread;
   he       : PHostEnt;
begin
   repeat
      try
         repeat
            len := sizeof(RemUser);
            DataSock := accept(LisSock, @RemUser, @len);
            Assert(DataSock<>INVALID_SOCKET, 'Unable to Accept');
            he := gethostbyaddr(@RemUser.sin_addr.S_addr, 4, RemUser.sin_family);

            dt := TDataThread.Create(True);
            dt.DataSock := DataSock;
            if he<>nil then dt.RemoteHost := he.h_name
               else dt.RemoteHost := 'Unknown';
            dt.Resume;

            Synchronize(UpdateHits);
         until FALSE;
      except
         on e: Exception do begin
            ErrMsg := e.Message + ' (Listen Thread)';
            Synchronize(ShowError);
         end;
      end;
   until False;
end;

procedure TListenThread.UpdateHits;
begin
   MainForm.UpdateHits;
end;

procedure TListenThread.ShowError;
begin
   MainForm.ErrorLab.Caption := ErrMsg;
end;

end.
